<?php
date_default_timezone_set('America/Recife');
/***
*	PROJETO MAIS SIMPLES
*
*	Imprime um documento jSon e executa as ações enviadas para esta página.
*	Ações:
*	1 -> Inserir Dados
*	2 -> Atualizar Dados
*	3 -> Excluir Dados
*	4 -> Retornar Dados
**/
header("Content-Type:text/plain"); // Define como documento de texto. Indispensável para JSON ser bem lido

include_once("conexao.php"); // Inclui Dados de Conexão

//Variáveis Padrões
$id 		= $_REQUEST['id']; //Id de referência
$acao	 	= $_REQUEST['acao']; //Ação para execução

//Em Caso de Insert ou Update
//Apenas carrega as variáveis se forem necessárias (economia de memória)
if(isset($_REQUEST['nfc'])){
	$nfc 				= $_REQUEST['nfc'];
	$data_envio 		= $_REQUEST['data_envio'];
	$data_confirmada 	= $_REQUEST['data_confirmada'];
	$latitude			= $_REQUEST['latitude'];
	$longitude			= $_REQUEST['longitude'];
	$foto				= $_REQUEST['foto'];
	
	$data_confirmada = date('Y-m-d h:i:s', time());
	
	print_r($data_confirmada);
}

//Inserir
if($acao=="1" && $id != 'undefined'){
	$data_confirmada = date('Y-m-d H:i:s', time());
	$sql = "INSERT INTO checkins (id,nfc,data_envio,data_confirmada,latitude,longitude,foto) ";
	$sql .= "VALUES (DEFAULT,'$nfc','$data_envio','$data_confirmada','$latitude','$longitude','$foto');";
	$result = mysqli_query($con,$sql);
	$id_inserido = mysqli_insert_id($con);

	if($result === FALSE) {
	    die("Houve um Erro ao Salvar: " . mysqli_error());
	}
	else{
		die('[{"id":"'.$id_inserido.'","mensagem":"Adicionado Com Sucesso"}]');
	}
}

//Atualizar
else if($acao=="2"){
	$sql = "UPDATE posts SET ";
	$sql .= "titulo='$titulo',";
	$sql .= "data_criacao='$dataCria',";
	$sql .= "conteudo='$conteudo',";
	$sql .= "meta_chaves='$mChaves',";
	$sql .= "meta_descricao='$mDesc',";
	$sql .= "meta_titulo='$mTitulo',";
	$sql .= "img_destaque='$imgDest',";
	$sql .= "autor='$autor',";
	$sql .= "categoria='$categoria'";
	$sql .= " WHERE id = $id;";
	
	$result = mysqli_query($con,$sql);

	if($result === FALSE) {
	    die("Houve um Erro ao Salvar o Artigo: ".mysqli_error());
	}else{
		die("Post Atualizado Com Sucesso");
	}
}

//Excluir
else if($acao=="3"){
	$sql = "DELETE FROM posts ";
	$sql .= " WHERE id = $id";
	
	$result = mysqli_query($con,$sql);

	if($result === FALSE) {
	    die($sql . mysqli_error());
	}else{
		die("Post Excluido Com Sucesso");
	}
}

//Retorna Somente uma Linha de Dados
else if($acao=="4" && $id != 'undefined'){
	$result = mysqli_query($con,"SELECT * FROM detentos WHERE nfc='$id'");
	
	if($result === FALSE) {
	    die(mysqli_error($con));
	}
	
	$got = array();
	
	while ($row = mysqli_fetch_array($result,MYSQL_ASSOC)) {
	  array_push($got, $row);
	}
	
	echo json_encode($got[0],JSON_PRETTY_PRINT);
	
	die();
}

else if($acao =="cat"){
	$result = mysqli_query($con,'SELECT * FROM categorias');
}

//Retorna Todos os Dados
else{
	$sql = "SELECT 
			ch.id as id,
			det.nfc as nfc,
			det.nome as nome,
			ch.data_envio as data_envio,
			ch.data_confirmada as data_confirmada,
			ch.latitude as latitude,
			ch.longitude as longitude,
			ch.foto as foto
			FROM
			 checkins ch,
			 detentos det
			WHERE det.nfc = ch.nfc
			ORDER BY data_confirmada DESC";
	if(isset($_REQUEST["last_id"])){
			$ultimo_id = $_REQUEST["last_id"];
			$sql = "SELECT 
			ch.id as id,
			det.nfc as nfc,
			det.nome as nome,
			ch.data_envio as data_envio,
			ch.data_confirmada as data_confirmada,
			ch.latitude as latitude,
			ch.longitude as longitude,
			ch.foto as foto
			FROM
			 checkins ch,
			 detentos det
			WHERE det.nfc = ch.nfc
			AND ch.id > $ultimo_id 
			ORDER BY data_confirmada DESC";
	}
	$result = mysqli_query($con,$sql);
}

if($result === FALSE) {
    die(mysqli_error($con));
}

$got = array();

while ($row = mysqli_fetch_array($result,MYSQL_ASSOC)) {
  array_push($got, $row);
}

$json = json_encode($got,JSON_PRETTY_PRINT);
echo $json;
?>