/**
Script de Localização de Locais 
@author Rodrigo Portillo
*/

//Variáveis Públicas
var actCoords = [];
var directionDisplay;
var directionsService = new google.maps.DirectionsService();
var route = false;
var map;
var marker;
var geocoder;


/**Localização atual**/
/*function getLocation()
{
  if (navigator.geolocation)
    {
       	navigator.geolocation.getCurrentPosition(showPosition,error);

    }
  else{
  //	alert("naofoiGeolocation");
  		//$("header").append("");
  		//$("#mapa").css("display", "none");
  	}
}*/
  
function showPosition(position){
  actCoords = [position.coords.latitude,position.coords.longitude];
//  alert(position.coords.latitude);
  carregar();
}
function error(msg) {
   
}

/**Init**/
//$(document).ready(function(){
	//getLocation(); //pegar localização
//});
//carregar div do mapa

    if ($("#mapa").text().length > 0) {
		$('#mapa').hide();
	} else{
		$('#mapa').show(); 
	}
	
	
	//Padrão do mapa
	var latlng = new google.maps.LatLng(-8.067783,-34.9378,17);
	
	actCoords[0] = -8.067783;
	actCoords[1] = -34.9378,17;
	
	if(actCoords[0] == undefined || actCoords[0] == null){
		$("#mapa").css("display", "none");
	}else{
		$("#mapa").css("display", "block");
	}
	
	var myOptions = {
		zoom: 14,
		center: latlng,
		streetViewControl:false,
		disableDoubleClickZoom:true,
		draggable:true,
		mapTypeControl:false,
		overviewMapControl:false,
		panControl:true,
		scaleControl:true,
		zoomControl:true,
		mapTypeId: google.maps.MapTypeId.ROADMAP
	};
	
	//criando o mapa
	map = new google.maps.Map(document.getElementById("mapa"), myOptions);
	
	while ($("#mapa").text().length > 0) {
		$('#mapa').hide();
	} 
	$('#mapa').show();
         
	
	var aqui = new google.maps.LatLng(-8.067783,-34.9378,17);
	
	/*marcadorPraca = new google.maps.Marker({
			position: aqui,
			map: map,
			title:"Você está aqui",
			icon: 'map-marker.png'
	});
	
	marcadorSegundo = new google.maps.Marker({
			position: new google.maps.LatLng(-8.0321982,-34.8705666),
			map: map,
			title:"Você está aqui",
			icon: 'map-marker.png'
	});*/
	
	
	


function recarregarMapa(){
	
	$.ajax({
		url: "/pacto/dados/checkins.php?acao=5",
		cache: false,
		dataType: 'json',
		beforeSend: function() {
		   // $("#slider_ballon").html("<center>Carregando...</center>");
	    },
		success: function(retorno){	
			
			locations = [];
			
			if(retorno.length>0){
			var valor = "";
				for(var i=0;i<retorno.length;i++){
					locations.push([retorno[i].nome,retorno[i].latitude,retorno[i].longitude,retorno[i].id]);
				} 
				
				
	
				//create empty LatLngBounds object
				var bounds = new google.maps.LatLngBounds();
				var infowindow = new google.maps.InfoWindow();    
				
				for (i = 0; i < locations.length; i++) {  
				  var marker = new google.maps.Marker({
				    position: new google.maps.LatLng(locations[i][1], locations[i][2]),
				    map: map
				  });
				
				  //extend the bounds to include each marker's position
				  bounds.extend(marker.position);
				
				  google.maps.event.addListener(marker, 'click', (function(marker, i) {
				    return function() {
				      infowindow.setContent(locations[i][0]);
				      infowindow.open(map, marker);
				    }
				  })(marker, i));
				}
				
				//now fit the map to the newly inclusive bounds
				map.fitBounds(bounds);
				
				//(optional) restore the zoom level after the map is done scaling
				var listener = google.maps.event.addListener(map, "idle", function () {
				    google.maps.event.removeListener(listener);
				});

			}
			
				
			
			
		}
	});
}

	


/**
* Carregar Mapa
*/
function carregarMapa(coorda,coordb,id){
	
	//Gerar novo Mapa
  	directionsDisplay = new google.maps.DirectionsRenderer();
  	geocoder = new google.maps.Geocoder();
  	var myLatlng = new google.maps.LatLng(coorda, coordb);	
  	
  	var myOptions = {
		zoom: 15,
		center: myLatlng,
		streetViewControl:false,
		disableDoubleClickZoom:true,
		draggable:false,
		mapTypeControl:false,
		overviewMapControl:false,
		panControl:false,
		scaleControl:false,
		zoomControl:false,
		mapTypeId: google.maps.MapTypeId.ROADMAP
		}
	//Verificar Largura da Janela para encaixar no mapa correto
	if($(window).width() < 800){
		if(id != "mapa"){
			$("#"+id).css("height","250px");
		}
		//Repetir comando de Mapa para corrigir resto de Carregamento
  		map = new google.maps.Map(document.getElementById(id), myOptions);
  		map = new google.maps.Map(document.getElementById(id), myOptions);
  	}else{
  		//Repetir comando de Mapa para corrigir resto de Carregamento
  		map = new google.maps.Map(document.getElementById(id), myOptions);
  		map = new google.maps.Map(document.getElementById(id), myOptions);
  	}
  	directionsDisplay.setMap(map);
  	
  	
    calcRoute(actCoords[0],actCoords[1],coorda,coordb); // Carregar Rota

  	//directionsDisplay.setPanel(document.getElementById("directionsPanel"));
}



//Específicos da Aplicação

var lastId = 0;

function carregaTodosCheckins(){
	$.ajax({
		url: "/pacto/dados/checkins.php",
		cache: false,
		dataType: 'json',
		beforeSend: function() {
		   // $("#slider_ballon").html("<center>Carregando...</center>");
	    },
		success: function(retorno){
			
			var valor = "";
			for(var i=0;i < retorno.length;i++){
				valor += "<li>";
				valor += '<article>';
				valor += '<div class="imagem">';
				valor += '<img src="data:image/jpg;base64,'+retorno[i].foto+'" class="ultima_imagem" title="Última Foto Registrada"/>';
				valor += '</div>';
				valor += '<div class="dados">';
				valor += '<header>';
				valor += '<h1>'+retorno[i].nome+'</h1>';
				valor += '<h2>Lat' + retorno[i].latitude +' Long'+retorno[i].longitude+'<img src="pin.png"/></h2>';
				valor += '<h3>'+retorno[i].data_envio+' ~ '+retorno[i].data_confirmada+'</h3>';
				valor += '</header>';
				valor += '</div>';
				valor += '</article>';
				valor += "</li>";
			
				//locations.push([retorno[i].nome,retorno[i].latitude,retorno[i].longitude,retorno[i].id]);
			} 
			lastId = retorno[0].id;
			console.debug("QCARREGA"+ lastId);
			$("#listaDetentos").html(valor);
			recarregarMapa();
		}
	});
}

function carregaCheckins(){
	$.ajax({
		url: "/pacto/dados/checkins.php?last_id="+lastId,
		cache: false,
		dataType: 'json',
		beforeSend: function() {
		   // $("#slider_ballon").html("<center>Carregando...</center>");
	    },
		success: function(retorno){	
			if(retorno.length>0){
			var valor = "";
				for(var i=0;i<retorno.length;i++){
					valor += "<li>";
					valor += '<article>';
					valor += '<div class="imagem">';
					valor += '<img src="data:image/jpg;base64,'+retorno[i].foto+'" class="ultima_imagem" title="Última Foto Registrada"/>';
					valor += '</div>';
					valor += '<div class="dados">';
					valor += '<header>';
					valor += '<h1>'+retorno[i].nome+'</h1>';
					valor += '<h2>Lat' + retorno[i].latitude +' Long'+retorno[i].longitude+'<img src="pin.png"/></h2>';
					valor += '<h3>'+retorno[i].data_envio+' ~ '+retorno[i].data_confirmada+'</h3>';
					valor += '</header>';
					valor += '</div>';
					valor += '</article>';
					valor += "</li>";
					
					//if(retorno[i].id>lastId){
				console.debug(retorno[i].id);
				if(retorno[i].id>lastId){
					console.debug(retorno[i].id);
					lastId = retorno[i].id;
				}
						
					//}
					
				//	locations.push([retorno[i].nome,retorno[i].latitude,retorno[i].longitude,retorno[i].id]);
				} 
				
				$("#listaDetentos").prepend(valor);
				recarregarMapa();
			}	
			
			
		}
	});
}

function verificarCheckins(){
	setInterval(function () {
		console.debug(lastId);
		carregaCheckins();
	}, 5000);
}


carregaTodosCheckins();
verificarCheckins();